/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2007 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.data.impl.sqlconfig;

import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.InvalidXmlDefinition;
import fr.gouv.finances.cp.utils.xml.marshal.XmlAttributes;
import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshallable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;

public class XsString implements XmlMarshallable {
	
	private String tagName;
	private StringBuffer sb;

	public XsString(String tagName) {
		super();
		this.tagName=tagName;
		sb = new StringBuffer();
	}

	public void addCharacterData(String cData) throws SAXException {
		sb.append(cData);
	}

	public void addChild(XmlMarshallable child, String tagName) throws SAXException { }

	public XmlMarshallable getAttributes(XmlAttributes attributes) throws SAXException {
		return this;
	}

	public void marshall(XmlOutputter output) {
		output.startTag(tagName);
		output.addCharacterData(getData());
		output.endTag(tagName);

	}

	public void validate() throws InvalidXmlDefinition { }
	
	public String getData() { return sb.toString(); }
	public void resetData () { sb.setLength(0); }
	@Override
	public XsString clone() {
		XsString other = new XsString(tagName);
		try { other.addCharacterData(getData()); } catch(Throwable t) {}
		return other;
	}

	@Override
	public boolean equals(Object obj) {
		if(obj instanceof String) return getData().equals(obj);
		return toString().equals(obj);
	}

	@Override
	public String toString() {
		return getData();
	}
	

}
